import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
/**
 * @hidden
 */
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    static $t: Type;
    protected cd(): SeriesView;
    getHostReferenceValue(): number;
    o2(a: SeriesView): void;
    xg: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    get RangeFramePreparer(): RangeCategoryFramePreparer;
    set RangeFramePreparer(a: RangeCategoryFramePreparer);
    xt: string;
    protected fo(): boolean;
    protected g1(): List$1<SeriesLayerPropertyOverlay>;
    private xw;
    private xv;
    jv(a: any, b: string): any;
    get lowColumn(): IFastItemColumn$1<number>;
    set lowColumn(a: IFastItemColumn$1<number>);
    private xi;
    xq: string;
    get highColumn(): IFastItemColumn$1<number>;
    set highColumn(a: IFastItemColumn$1<number>);
    private xh;
    xo: string;
    xm: string;
    protected vy(): CategoryTransitionInMode;
    w7(a: CategoryFrame, b: CategorySeriesView): void;
    protected xx(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    ar(a: Rect): AxisRange;
    fp(a: any): boolean;
    protected pa(a: any, b: string, c: any, d: any): void;
    aq(a: Axis): AxisRange;
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    w4(a: CategoryFrame, b: CategorySeriesView): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get mayContainUnknowns(): boolean;
    pt(a: Rect, b: RenderSurface): void;
    private xe;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    h3(): number;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RangeCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c3: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    c4(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    cv(): CategoryBucketCalculator;
}
